:-module(prolog2xml,[pro2xml/2]).

%-------------------------------------------------------------------------
%
%   PROLOG -> XML
%
% by Jorge Coelho  jcoelho@dei.isep.ipp.pt
%    Mrio Florido amf@ncc.up.pt
%
%-------------------------------------------------------------------------


pro2xml(Term,File):-
	tell(File),
	Term=..List,
	conv(List,0),
	told.


conv([[]],_):-!.


conv([X],N):-!,
	X=..List,
	conv(List,N).


conv([.,X|R],N):-!,
	X=..List,
	conv(List,N),
	conv(R,N).


conv([TagN,Atr],N):-!,
	nl,tabulacao(N),
	write('<'),write(TagN),
	processa_attr(Atr),
	write('/>').


conv([TagN,Atr|Rl],N):-
	nl,tabulacao(N),
	write('<'),write(TagN),
	processa_attr(Atr),
	write('>'),
	N1 is N+1,
	conteudo(Rl,N1),
	nl,tabulacao(N),
	write('</'),write(TagN),write('>').



conteudo([],_).

conteudo([X],N):-
	atom(X),!,
	nl,tabulacao(N),
	write(X).

conteudo([[X]],N):-
	atom(X),!,
	nl,tabulacao(N),
	write(X).

conteudo([X|R],N):-
	X=..ListX,
	conv(ListX,N),
	conteudo(R,N).



processa_attr([]).

processa_attr([attribute(X,Y)|R]):-
	write(' '),write(X),write('='),write(Y),
	processa_attr(R).
     

tabulacao(0):-!.

tabulacao(N):-
	write('\t'),
	N1 is N - 1,
	tabulacao(N1).

