:-module(replace,[replace/5,vars/2]).
:-op(800,xfx,--->).


replace(X,[],X,E,E).

replace(G,[(_,B)|R],G2,E1,E2):-
	contvars(B,E1),!,
	replace(G,R,G2,E1,E2).

replace(G,[(A,B)|R],G3,E1,E3):-
	replace2(A,B,G,G2,E1,E2),!,
	replace(G2,R,G3,E2,E3).


replace2(A,B,A,B,E1,E2):-
	union([A],E1,E2).

replace2(A,B,G,G2,E1,E2):-
	G=..[F|R],
	length(R,N),
	N>0,
	F\=type_,
	F\=var_,!,
	replace3(A,B,R,R2,E1,E2),
	G2=..[F|R2].

replace2(_,_,X,X,E,E).


replace3(_,_,[],[],E,E).

replace3(A,B,[X|R1],[Y|R2],E1,E3):-
	replace2(A,B,X,Y,E1,E2),
	replace3(A,B,R1,R2,E2,E3).
	

length([],0).

length([_|R],N):-
	length(R,N1),
	N is N1 + 1.


contvars(B,E):-
	B=..L,
	vars(L,L2),
	membs(L2,E).


membs(B,E):-
	member(X,E),
	member(X,B).


vars([],[]).

vars([var_(X)|R],[var_(X)|R2]):-!,
	vars(R,R2).

vars([X|R],R3):-!,
	X=..[_|C],
	vars(C,R1),	
	vars(R,R2),
	append(R1,R2,R3).
